---
title: IDBFactory
slug: Web/API/IDBFactory
tags:
  - API
  - HTTP
  - IndexedDB
  - Interface
  - Offline
  - Reference
  - Storage
---
<p>{{APIRef("IndexedDB")}}</p>

<div>
<p>The <strong><code>IDBFactory</code></strong> interface of the <a href="/en-US/docs/IndexedDB">IndexedDB API</a> lets applications asynchronously access the indexed databases. The object that implements the interface is <code>window.indexedDB</code>. You open — that is, create and access — and delete a database with this object, and not directly with <code>IDBFactory</code>.</p>

<p>{{AvailableInWorkers}}</p>
</div>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("IDBFactory.open")}}</dt>
 <dd>The current method to request opening a <a href="/en-US/docs/IndexedDB#gloss_database_connection">connection to a database</a>.</dd>
 <dt>{{domxref("IDBFactory.deleteDatabase")}}</dt>
 <dd>A method to request the deletion of a database.</dd>
 <dt>{{domxref("IDBFactory.cmp")}}</dt>
 <dd>A method that compares two keys and returns a result indicating which one is greater in value.</dd>
 <dt>{{domxref("IDBFactory.databases")}}</dt>
 <dd>A method that returns a list of all available databases, including their names and versions.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>In the following code snippet, we make a request to open a database, and include handlers for the success and error cases. For a full working example, see our <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> app (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</p>

<pre class="brush:js;highlight:[10]">// In the following line, you should include the prefixes of implementations you want to test.
window.indexedDB = window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
// DON'T use "var indexedDB = ..." if you're not in a function.
// Moreover, you may need references to some window.IDB* objects:
window.IDBTransaction = window.IDBTransaction || window.webkitIDBTransaction || window.msIDBTransaction;
window.IDBKeyRange = window.IDBKeyRange || window.webkitIDBKeyRange || window.msIDBKeyRange;
// (Mozilla has never prefixed these objects, so we don't need window.mozIDB*)

// Let us open version 4 of our database
var DBOpenRequest = window.indexedDB.open("toDoList", 4);

// these two event handlers act on the database being opened successfully, or not
DBOpenRequest.onerror = function(event) {
  console.error("Error loading database.");
};

DBOpenRequest.onsuccess = function(event) {
  console.info("Database initialised.");

  // store the result of opening the database in the db variable. This is used a lot later on, for opening transactions and suchlike.
  db = DBOpenRequest.result;
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB", "#idbfactory", "IDBFactory")}}</td>
   <td>{{Spec2("IndexedDB")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#factory-interface", "IDBFactory")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBFactory")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
